"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.copyIndependencyTemplate = exports.makePackageJsonIndependent = exports.makeTsconfigJsonIndependent = void 0;
var tslib_1 = require("tslib");
var fs_extra_1 = tslib_1.__importDefault(require("fs-extra"));
var path_1 = tslib_1.__importDefault(require("path"));
var migration_1 = require("../../setup/migration");
var removeNestedNodeModulesTypes = function (typeRoots) {
    var _a;
    var types = 'node_modules/@types';
    var updatedTypeRoots = [types];
    if (typeRoots !== undefined) {
        var filtered = (_a = typeRoots.filter(function (typeRoot) { return !typeRoot.includes(types); })) !== null && _a !== void 0 ? _a : [];
        updatedTypeRoots.push.apply(updatedTypeRoots, tslib_1.__spread(filtered));
    }
    return updatedTypeRoots;
};
exports.makeTsconfigJsonIndependent = function (path, data) {
    var updatedTsconfigJson = tslib_1.__assign({}, data);
    if (updatedTsconfigJson.compilerOptions !== undefined) {
        updatedTsconfigJson.compilerOptions.typeRoots = removeNestedNodeModulesTypes(updatedTsconfigJson.compilerOptions.typeRoots);
    }
    return fs_extra_1.default.outputJSON(path, updatedTsconfigJson, { spaces: 2 });
};
exports.makePackageJsonIndependent = function (path, data) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var _a, _b;
    return tslib_1.__generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4 /*yield*/, fs_extra_1.default.outputJSON(path, tslib_1.__assign(tslib_1.__assign({}, data), { dependencies: tslib_1.__assign(tslib_1.__assign({}, ((_a = data === null || data === void 0 ? void 0 : data.dependencies) !== null && _a !== void 0 ? _a : {})), migration_1.migrationSetup.independency.dependencies), devDependencies: tslib_1.__assign(tslib_1.__assign({}, ((_b = data === null || data === void 0 ? void 0 : data.devDependencies) !== null && _b !== void 0 ? _b : {})), migration_1.migrationSetup.independency.devDependencies) }), { spaces: 2 })];
            case 1: return [2 /*return*/, _c.sent()];
        }
    });
}); };
exports.copyIndependencyTemplate = function (dir) {
    return fs_extra_1.default.copy(path_1.default.resolve(__dirname, '../../../../templates/migration/independency'), dir, { overwrite: true, errorOnExist: false });
};
